package plugins;

import jBLAS.Volume;

/**
 * @author Jiri Trnka
 */
public class TestApp extends BasePlugIn {

    /** Inherited from BasePlugIn:
     *  The fields are automatically set by the main application when plug-in is started
     * 
     *      protected double[][][] pixelData;       // data volume [frames][rows][columns]
     *      protected int planeView;                // actual view TRA | COR | SAG
     *      protected int[] position;               // actual position [frame (tra), row (cor), column (sag)]
     *      protected float[] dimensions;           // pixel sizes in mm [frame (tra), row (cor), column (sag)]
     *
    * 
    **/
    
    private Volume imageVolume;
    
    public TestApp() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        minButton = new javax.swing.JButton();
        resultLabel = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        maxButton = new javax.swing.JButton();
        sumButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        crossPositionLabel = new javax.swing.JLabel();
        voxelValueLabel = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel5 = new javax.swing.JLabel();
        viewLabel = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        dimensionsLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Sample plug-in");
        setMinimumSize(new java.awt.Dimension(435, 320));
        setResizable(false);
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        minButton.setText("Min");
        minButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                minButtonActionPerformed(evt);
            }
        });
        getContentPane().add(minButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 190, 83, -1));

        resultLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        resultLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        resultLabel.setText("N/A");
        getContentPane().add(resultLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 230, 320, -1));

        jLabel2.setForeground(java.awt.Color.blue);
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("Sample plug-in");
        getContentPane().add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(12, 12, 400, -1));

        maxButton.setText("Max");
        maxButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                maxButtonActionPerformed(evt);
            }
        });
        getContentPane().add(maxButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 190, 83, -1));

        sumButton.setText("Sum");
        sumButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sumButtonActionPerformed(evt);
            }
        });
        getContentPane().add(sumButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 190, 83, -1));

        jLabel1.setText("Cross position");
        getContentPane().add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 70, -1, 20));

        jLabel3.setText("Voxel value");
        getContentPane().add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 95, -1, 20));

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setText("Calculate volume statistics");
        getContentPane().add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 160, 320, -1));

        crossPositionLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        crossPositionLabel.setText("N/A");
        getContentPane().add(crossPositionLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 70, 170, 20));

        voxelValueLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        voxelValueLabel.setText("N/A");
        getContentPane().add(voxelValueLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 95, 170, 20));
        getContentPane().add(jSeparator1, new org.netbeans.lib.awtextra.AbsoluteConstraints(12, 33, 400, 10));
        getContentPane().add(jSeparator2, new org.netbeans.lib.awtextra.AbsoluteConstraints(12, 278, 400, 10));

        jLabel5.setText("Current view");
        getContentPane().add(jLabel5, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 50, -1, -1));

        viewLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        viewLabel.setText("N/A");
        getContentPane().add(viewLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 50, 170, -1));

        jLabel7.setText("Voxel dimensions");
        getContentPane().add(jLabel7, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 120, -1, -1));

        dimensionsLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        dimensionsLabel.setText("N/A");
        getContentPane().add(dimensionsLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 120, 170, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void minButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_minButtonActionPerformed
        // TODO add your handling code here:
        resultLabel.setText(imageVolume.getMin() + "");
    }//GEN-LAST:event_minButtonActionPerformed

    private void maxButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_maxButtonActionPerformed
        // TODO add your handling code here:
        resultLabel.setText(imageVolume.getMax() + "");        
    }//GEN-LAST:event_maxButtonActionPerformed

    private void sumButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sumButtonActionPerformed
        // TODO add your handling code here:
        resultLabel.setText(imageVolume.getSum() + "");
    }//GEN-LAST:event_sumButtonActionPerformed


    @Override
    public void autoRun() {
        // this code is run automatically when plug-in is started
        
        crossPositionLabel.setText("TRA: " + position[0] + " COR: " + position[1] + " SAG: " + position[2]);
        voxelValueLabel.setText(pixelData[position[0]][position[1]][position[2]] + "");
        dimensionsLabel.setText(dimensions[0] + " x " + dimensions[1] + " x " + dimensions[2] + " mm");
        
        switch (planeView) {
            case BasePlugIn.TRANSAXIAL: 
                viewLabel.setText("Transaxial"); 
                break;
            case BasePlugIn.CORONAL: 
                viewLabel.setText("Coronal"); 
                break;
            case BasePlugIn.SAGITTAL: 
                viewLabel.setText("Sagittal"); 
                break;
        }
        
        imageVolume = new Volume(pixelData); // convenient for advanced mathematical operations with the data, see calc statistics methods
    }
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel crossPositionLabel;
    private javax.swing.JLabel dimensionsLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JButton maxButton;
    private javax.swing.JButton minButton;
    private javax.swing.JLabel resultLabel;
    private javax.swing.JButton sumButton;
    private javax.swing.JLabel viewLabel;
    private javax.swing.JLabel voxelValueLabel;
    // End of variables declaration//GEN-END:variables
}
